package main

import (
	"fmt"
	"sync"
)

func main() {
	var sum int
	group := &sync.WaitGroup{}
	lock := &sync.Mutex{}

	add := func(group *sync.WaitGroup) {
		defer group.Done()
		for i := 0; i < 100; i++ {
			lock.Lock() // 加锁
			sum += i
			lock.Unlock() // 是否锁
		}
	}
	diff := func(group *sync.WaitGroup) {
		defer group.Done()
		for i := 0; i < 100; i++ {
			lock.Lock() // 加锁
			sum -= i
			lock.Unlock() // 是否锁
		}
	}

	for i := 0; i < 5; i++ {
		group.Add(2)
		go add(group)
		go diff(group)
	}

	group.Wait()
	fmt.Println(sum)
}
